#pragma once

#include "../core.h"
#include "../classes/draw.h"

void Draw::number(Dword value,Dword digitsNum,Word x,Word y,Dword colour,eNumberBase nBase, bool valueIsPointer) {
	Dword arg1, arg2;

	//
	arg1 = ( valueIsPointer ? 1 : 0 ) |
		( ((Byte)nBase) << 8 ) |
		( ( digitsNum & 0x1F ) << 16 );
	arg2 = ( x << 16 ) | y;
	//
	__asm{
		push 47
		pop eax
		mov ebx, arg1
		mov ecx, value
		mov edx, arg2
		mov esi, colour
		int 0x40
	}
}

//  
void Draw::offcut(int startX, int startY, int endX, int endY, int color, bool inverse) {
	int x,y;
	x = startX*65536 + endX;
	y = startY*65536 + endY;

	color = (!inverse) ? color : 0x01000000;

	__asm{
		push 38
		pop eax
		mov ebx, x
		mov ecx, y
		mov edx, color
		int 0x40
	}
}

//  
void Draw::pixel(Dword x, Dword y, Dword pxColor) {
	__asm{
		push 1
		pop eax
		mov ebx, x
		mov ecx, y
		mov edx, pxColor
		int 0x40
	}
}