#include <kosSyst.h>
#include <kosFile.h>

#include "mylib/core.h"
#include "mylib/components/dll.h"

#include "mylib/modules/numberLabel.h"
#include "mylib/modules/pixels.h"
#include "mylib/modules/offcut.h"
#include "mylib/modules/pixel.h"

#include "mylib/modules/boxlib/init.h"

class ApplicationWindow : public Window {
public:
	Label* txt;
	NumberLabel* num;
	ApplicationWindow();
	void init();
};

void kos_Main() {
	ApplicationWindow* win = new ApplicationWindow;
	Application::setWindow(win);
	Application::run();
}

void ApplicationWindow::init() {
	this->header = (Dword)"Hello, World!";
	this->sizeX = 500;
	this->sizeY = 500;
	
	kos_SetMaskForEvents(0x27);

	this->txt = new Label();
	this->txt->x = 10;
	this->txt->y = 10;
	this->txt->text = "Test Text";

	this->num = new NumberLabel(25, 2);
	this->num->x = 10;
	this->num->y = 30;

	//  
	BoxLib::init();
	BoxLib::initEditBox();

	EditBox* ebox = new EditBox(50, 50, 100);

	EditBox* ebox2 = new EditBox(50, 90, 100);
	EditBox* ebox3 = new EditBox(180, 120, 100);

	this->addControl(this->txt);
	this->addControl(this->num);
	this->addControl(ebox);
	this->addControl(ebox2);
	this->addControl(ebox3);
}

ApplicationWindow::ApplicationWindow() {

}