#include "../core.h"
#include "../classes/events.h"

#include "../modules/button.h"

Button::Button() {
	x = 0;
	y = 0;
	sizeX = 30;
	sizeY = 10;
	id = 0;
	color = COLOR_RED;
	hidden = false;
	type = CONTROL_BUTTON;
}

void Button::draw() {
	if (!hidden) kos_DefineButton(x, y, sizeX, sizeY, id, color );
	this->call(EVENT_DRAW);
}

int Button::getType() {
	return CONTROL_BUTTON;
}

int Button::getId() {
	return this->id;
}