#include "../core.h"
#include "../classes/events.h"

#include "../modules/label.h"

Label::Label() {
	x = 0;
	y = 0;
	id = 0;
	color = COLOR_BLACK;
	hidden = false;
	fontType = 0x80;
	text = "Test";
	textlen = 0;
}

void Label::draw() {
	if (!hidden) kos_WriteTextToWindow(x, y, fontType, color, text, textlen);
	this->call(EVENT_DRAW);
}


int Label::getType() {
	return CONTROL_LABEL;
}

int Label::getId() {
	return this->id;
}