#pragma once

#include "../core.h"
#include "numberLabel.h"
#include "../classes/draw.h"

NumberLabel::NumberLabel(int number, int numDigits) {
	this->x = 0;
	this->y = 0;
	this->num = number;
	this->digits = numDigits;
	this->id = 0;
	this->color = COLOR_BLACK;
}

int NumberLabel::getType() {
	return CONTROL_NUMBER_LABEL;
}

int NumberLabel::getId() {
	return this->id;
}

//  1  
void NumberLabel::draw() {
	this->call(EVENT_DRAW);
	Draw::number(this->num, this->digits, this->x, this->y, this->color);
}