#include "../core.h"
#include "pixel.h"
#include "../classes/draw.h"

Pixel::Pixel(int x=10, int y=0, Dword color=COLOR_GREEN) {
	this->x = x;
	this->y = y;
	this->color = color;

	this->id = 0;
}

void Pixel::draw() {
	this->call(EVENT_DRAW);
	Draw::pixel(this->x, this->y, this->color);
}

int Pixel::getType() {
	return CONTROL_PIXEL;
}

int Pixel::getId() {
	return this->id;
}